diff --git a/src/backend/commands/trigger.c b/src/backend/commands/trigger.c
index 240e85e391..3c9ce9be0c 100644
--- a/src/backend/commands/trigger.c
+++ b/src/backend/commands/trigger.c
@@ -3399,7 +3399,10 @@ ltrmark:;
 	}
 
 	if (HeapTupleHeaderGetNatts(tuple.t_data) < relation->rd_att->natts)
+	{
 		result = heap_expand_tuple(&tuple, relation->rd_att);
+		result->t_self = *tid;
+	}
 	else
 		result = heap_copytuple(&tuple);
 	ReleaseBuffer(buffer);
